
!EncoderForV3 methodsFor: '*MethodMassageCompatibility-bytecode generation' stamp: 'eem 4/9/2013 12:07'!
genSendSpecial: specialSelectorIndex numArgs: nArgs
	"See BlueBook page 596"
	self assert: (specialSelectorIndex between: 1 and: Smalltalk specialSelectorSize).
	self assert: nArgs = (Smalltalk specialNargsAt: specialSelectorIndex).
	"Special selector sends.
		176-191 	1011iiii 	Send Arithmetic Message #iiii
		192-207 	1100iiii 	Send Special Message #iiii"
	stream nextPut: specialSelectorIndex + 175! !

!CompiledMethod methodsFor: '*MethodMassageCompatibility-accessing' stamp: 'eem 4/9/2013 12:16'!
voidCogVMState
	"Tell the VM to remove all references to any machine code form of the method.
	 This primitive must be called whenever a method is in use and modified.  This is
	 more aggressive (and *much* more costly) than flushCache since it must search
	 through all context objects, making sure that none have a (hidden) machine code pc
	 in the receiver.  Since modifying a method will likely change the generated machine code,
	 modifying a method (rather than redefining it) requires this more aggressive flush."

	<primitive: 215>
	^self primitiveFailed! !

!BytecodeEncoder methodsFor: '*MethodMassageCompatibility-opcode sizing' stamp: 'eem 4/9/2013 12:06'!
sizeSpecialSend: specialSelectorIndex numArgs: nArgs
	^self sizeOpcodeSelector: #genSendSpecial:numArgs: withArguments: {specialSelectorIndex. nArgs}! !
